/* log.c 

   Routines for writing to the log file.

 Chris Eleveld      (The Insane Hermit)
 Robert Slaven      (The Celestial Knight/Tigger)
 Jerry Bolton, Jr.  (Creel)
 Daniel Lawrence    (bergon)
 
*/

#include <stdio.h>

#if defined (STRICT_BSD) || defined (BSD)
#  include <strings.h>
#else
#  include <string.h>
#endif

#include "lorien.h"

static FILE *fpLOG = (FILE *)0;

/** Get time of day **/
char * timeset()
{
    long int buf; /* Should be time_t */
    char * sp, * cp;

    char * ctime();

	/* Get system time */
    time(&buf);

	/* Pass system time to converter */
    sp = ctime(&buf);

	/* Eat newline character */
    for (cp = sp; *cp; cp++)
	if (*cp == '\n') {
	    *cp = '\0';
	    break;
	}
    return(sp);
}

int log(what)

    char *what;

{
    char *buf;

#ifndef LOG
    return 0;
#endif

	/* remove unwanted characters \r and \n for now */

    if ((buf = (char *) index(what, '\r')) != (char *)0) 
	*buf = '\000';
    if ((buf = (char *) index(what, '\n')) != (char *)0)
	*buf = '\000';

	/* do we have the file open yet? */

    if (fpLOG == NULL)
	fpLOG = fopen(LOGFILE, "a");   /* Creel */

	/* dump it out saying who we are */

    fprintf(fpLOG,"lorien: %s %s\n", timeset(), what);
    fflush(fpLOG); 

    return 0;
}


int
purgelog(pplayer)
    struct splayer *pplayer;
{

    if (pplayer->seclevel < SUPREME) 
	return 0;

#ifndef LOG   
    return 1;
#endif

    fflush(fpLOG);
    fclose(fpLOG);
    fpLOG = fopen(LOGFILE,"w");
    fprintf(fpLOG,"lorien: %s %s purged the log.\n", timeset(), pplayer->name);
    fflush(fpLOG);
   
    return 1;
}

